
import { _decorator, Component, Node, Prefab, Sprite, instantiate, Camera, v3, Color, RenderTexture, Size, SpriteFrame } from 'cc';
const { ccclass, property } = _decorator;

/**
 * Predefined variables
 * Name = mian
 * DateTime = Fri Jan 21 2022 15:47:15 GMT+0800 (中国标准时间)
 * Author = 轰天传说
 * FileBasename = mian.ts
 * FileBasenameNoExtension = mian
 * URL = db://assets/mian.ts
 * ManualUrl = https://docs.cocos.com/creator/3.4/manual/zh/
 *
 */

@ccclass('main')
export class main extends Component {
    @property(Prefab)
    pre: Prefab = null;
    @property(Sprite)
    head: Sprite = null;
    @property(Node)
    canvas: Node = null;
    headNode: Node = null;
    plyNode: Node = null;
    start() {
        this.headNode = instantiate(this.head.node);
        this.headNode.parent = this.canvas;
        this.plyNode = instantiate(this.pre);
        this.plyNode.parent = this.canvas;
        this.plyNode.position = v3(1920, 1920, 0);
    }
    onClick(e) {
        let targetName: string = e.target.name;
        if (targetName == "btn") {
            this.headNode.active = false;
            this.scheduleOnce(() => {
                this.headNode.active = true;
            })
        } else if (targetName == "screen") {
            this.renderTextureCamera(this.headNode, this.plyNode.getChildByName("Camera").getComponent(Camera))
        }
    }
    renderTextureCamera(headNode: Node, ca: Camera) {
        if (headNode) {
            let renderTextture = new RenderTexture();
            renderTextture.reset(new Size(220, 153));
            ca.node.active = true;
            ca.targetTexture = renderTextture;
            let newSpFrame = new SpriteFrame();
            newSpFrame.texture = renderTextture;
            headNode!.getComponent(Sprite)!.spriteFrame = newSpFrame;
        }
        this.scheduleOnce(() => {
            if (ca.node) {
                ca.node.active = false;
            }
        }, 0)
    }
}
